"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.normalizeBlockType = exports.getBlockChildrenAll = void 0;
var createChildrenRequest = function (parent, requestParameters, databaseQueryFilter) {
    return parent.type === 'database'
        ? queryDatabaseAll({
            requestParameters: __assign(__assign({}, requestParameters), { entry_id: parent.id, entry_type: 'database' }),
            parent: parent,
            filter: databaseQueryFilter
        })
        : (0, exports.getBlockChildrenAll)({
            requestParameters: __assign(__assign({}, requestParameters), { entry_id: parent.id, entry_type: 'block' }),
            parent: parent
        });
};
/**
 * Get all entities (with properties) from the database.
 */
var queryDatabaseAll = function (_a) {
    var requestParameters = _a.requestParameters, parent = _a.parent, filter = _a.filter, _b = _a._entity_list, _entity_list = _b === void 0 ? [] : _b, _c = _a._cursor, _cursor = _c === void 0 ? undefined : _c;
    return __awaiter(void 0, void 0, void 0, function () {
        var _d, results, next_cursor, combinedResults;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    if (!requestParameters.entry_id || !requestParameters.entry_key) {
                        throw Error("RequestParameters are incorrect. \n\t\tPlease check if the integration key is added to sharing configuration of the database.\n\t\tid: ".concat(requestParameters.entry_id, "\n\t\tkey: ").concat(requestParameters.entry_key));
                    }
                    return [4 /*yield*/, requestParameters.client.databases.query({
                            database_id: requestParameters.entry_id,
                            auth: requestParameters.entry_key,
                            start_cursor: _cursor,
                            filter: filter
                        })];
                case 1:
                    _d = _e.sent(), results = _d.results, next_cursor = _d.next_cursor;
                    combinedResults = __spreadArray(__spreadArray([], _entity_list, true), results.map(function (result) {
                        return ({
                            id: result.id,
                            type: 'page',
                            metadata: result,
                            blockContentPlainText: '',
                            children: [],
                            depth: parent.depth + 1
                        });
                    }), true);
                    next_cursor &&
                        queryDatabaseAll({
                            requestParameters: requestParameters,
                            parent: parent,
                            _entity_list: combinedResults,
                            _cursor: next_cursor,
                            filter: filter
                        });
                    return [2 /*return*/, combinedResults];
            }
        });
    });
};
/**
 * Get all entities (with properties) from the database.
 */
var getBlockChildrenAll = function (_a) {
    var requestParameters = _a.requestParameters, parent = _a.parent, _b = _a._entity_list, _entity_list = _b === void 0 ? [] : _b, _c = _a._cursor, _cursor = _c === void 0 ? undefined : _c;
    return __awaiter(void 0, void 0, void 0, function () {
        var _d, results, next_cursor, resultsWithMetadata, combinedResults;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    if (!requestParameters.entry_id || !requestParameters.entry_key) {
                        throw Error("RequestParameters are incorrect. \n\t\tPlease check if the integration key is added to sharing configuration of the database.\n\t\tid: ".concat(requestParameters.entry_id, "\n\t\tkey: ").concat(requestParameters.entry_key));
                    }
                    return [4 /*yield*/, requestParameters.client.blocks.children.list({
                            block_id: requestParameters.entry_id,
                            auth: requestParameters.entry_key,
                            start_cursor: _cursor
                        })];
                case 1:
                    _d = _e.sent(), results = _d.results, next_cursor = _d.next_cursor;
                    resultsWithMetadata = results;
                    combinedResults = __spreadArray(__spreadArray([], _entity_list, true), resultsWithMetadata.map(function (result) {
                        return ({
                            id: result.id,
                            type: (0, exports.normalizeBlockType)(result.type),
                            metadata: result,
                            blockContentPlainText: '',
                            children: [],
                            depth: parent.depth + 1
                        });
                    }), true);
                    next_cursor &&
                        (0, exports.getBlockChildrenAll)({
                            requestParameters: requestParameters,
                            parent: parent,
                            _entity_list: combinedResults,
                            _cursor: next_cursor
                        });
                    return [2 /*return*/, combinedResults];
            }
        });
    });
};
exports.getBlockChildrenAll = getBlockChildrenAll;
/**
 * Reduce block types into three types : page, database and block (all the others)
 */
var normalizeBlockType = function (entity_type) {
    var type = entity_type === 'child_database'
        ? 'database'
        : entity_type === 'child_page'
            ? 'page'
            : 'block';
    return type;
};
exports.normalizeBlockType = normalizeBlockType;
exports.default = createChildrenRequest;
