"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.setupServer = void 0;
var express_1 = __importDefault(require("express"));
var page_1 = require("./handlers/page");
var search_1 = require("./handlers/search");
var tree_1 = require("./handlers/tree");
var suggestion_1 = require("./handlers/suggestion");
var log_1 = require("../utils/log");
var app = (0, express_1.default)();
var setupServer = function (port, data_set) {
    (0, page_1.pageServerHandler)(app, data_set);
    (0, tree_1.treeServerHandler)(app, data_set);
    (0, search_1.searchServerHandler)(app, data_set);
    (0, suggestion_1.suggestionServerHandler)(app, data_set);
    return app.listen(port, function () { return (0, log_1.stdout)("Express server listening ".concat([port], ".")); });
};
exports.setupServer = setupServer;
