export declare type QueryablePromise<T, E> = Promise<T> & queryablePromiseProperties<T, E>;
interface queryablePromiseProperties<T, E> {
    isPending: () => boolean;
    isRejected: () => boolean;
    isFulfilled: () => boolean;
    getResolvedValue: () => T;
    getRejectedValue: () => E;
    getPayloadValue: () => unknown;
    abort: () => boolean;
}
export declare function makeQueryablePromise<T, E>(promise: Promise<T>, payload?: unknown): QueryablePromise<T, E>;
export {};
